Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/AStarAlgorithmV3.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/AStarAlgorithmV3.cs	(revision 8515)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/AStarAlgorithmV3.cs	(revision 8516)
@@ -2,5 +2,6 @@
 using System;
 using System.Collections.Generic;
-using HeuristicLab.Problems.RoutePlanning.Graph;
+using HeuristicLab.Algorithms.GraphRouting.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
 namespace HeuristicLab.Algorithms.GraphRouting {
   public class AStarAlgorithmV3 : IRouter {
Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/BidirectionalDijkstraAlgorithmV2.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/BidirectionalDijkstraAlgorithmV2.cs	(revision 8515)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/BidirectionalDijkstraAlgorithmV2.cs	(revision 8516)
@@ -2,5 +2,6 @@
 using System;
 using System.Collections.Generic;
-using HeuristicLab.Problems.RoutePlanning.Graph;
+using HeuristicLab.Algorithms.GraphRouting.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
 namespace HeuristicLab.Algorithms.GraphRouting {
   public class BidrectionalDijkstraAlgorithmV2 : IRouter {
Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/DijkstraAlgorithmV2.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/DijkstraAlgorithmV2.cs	(revision 8515)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/DijkstraAlgorithmV2.cs	(revision 8516)
@@ -2,5 +2,6 @@
 using System;
 using System.Collections.Generic;
-using HeuristicLab.Problems.RoutePlanning.Graph;
+using HeuristicLab.Algorithms.GraphRouting.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
 namespace HeuristicLab.Algorithms.GraphRouting {
   public class DijkstraAlgorithmV2 : IRouter {
Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/HeuristicLab.Algorithms.GraphRouting.csproj
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/HeuristicLab.Algorithms.GraphRouting.csproj	(revision 8515)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/HeuristicLab.Algorithms.GraphRouting.csproj	(revision 8516)
@@ -57,17 +57,13 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AStarAlgorithm.cs" />
-    <Compile Include="AStarAlgorithmV2.cs" />
-    <Compile Include="BidirectionalDijkstraAlgorithm.cs" />
     <Compile Include="AStarAlgorithmV3.cs" />
     <Compile Include="BidirectionalDijkstraAlgorithmV2.cs" />
     <Compile Include="DijkstraAlgorithmV2.cs" />
-    <Compile Include="DijkstraAlgorithm.cs" />
     <Compile Include="GraphRoutingAlgorithm.cs" />
-    <Compile Include="IRouter.cs" />
-    <Compile Include="Pair.cs" />
+    <Compile Include="Interfaces\IRouter.cs" />
+    <Compile Include="Utilities\Pair.cs" />
     <Compile Include="Plugin.cs" />
-    <Compile Include="PriorityQueue.cs" />
-    <Compile Include="PriorityQueueOld.cs" />
+    <Compile Include="Utilities\PriorityQueue.cs" />
+    <Compile Include="Utilities\PriorityQueueOld.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Interfaces/IRouter.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Interfaces/IRouter.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Interfaces/IRouter.cs	(revision 8516)
@@ -0,0 +1,6 @@
+﻿
+namespace HeuristicLab.Algorithms.GraphRouting.Interfaces {
+  public interface IRouter {
+    long[] Calculate(long sourceNodeId, long targetNodeId);
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/Pair.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/Pair.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/Pair.cs	(revision 8516)
@@ -0,0 +1,38 @@
+﻿
+using System;
+using System.Collections.Generic;
+namespace HeuristicLab.Algorithms.GraphRouting.Utilities {
+  public class Pair<T> {
+    public T First { get; private set; }
+    public T Second { get; private set; }
+
+    public Pair(T first, T second) {
+      First = first;
+      Second = second;
+    }
+
+    public override int GetHashCode() {
+      return First.GetHashCode() ^ Second.GetHashCode();
+    }
+
+    public override bool Equals(object other) {
+      Pair<T> pair = other as Pair<T>;
+      if (pair == null) {
+        return false;
+      }
+      return (this.First.Equals(pair.First) && this.Second.Equals(pair.Second));
+    }
+  }
+
+  class PairComparer<T> : IComparer<Pair<T>> where T : IComparable {
+    public int Compare(Pair<T> x, Pair<T> y) {
+      if (x.First.CompareTo(y.First) < 0) {
+        return -1;
+      } else if (x.First.CompareTo(y.First) > 0) {
+        return 1;
+      } else {
+        return x.Second.CompareTo(y.Second);
+      }
+    }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/PriorityQueue.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/PriorityQueue.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/PriorityQueue.cs	(revision 8516)
@@ -0,0 +1,181 @@
+﻿
+using System;
+using System.Collections;
+using System.Collections.Generic;
+namespace HeuristicLab.Algorithms.GraphRouting.Utilities {
+  public class PriorityQueue<TPriority, TValue> : ICollection<KeyValuePair<TPriority, TValue>> {
+    private List<KeyValuePair<TPriority, TValue>> heap;
+    private Dictionary<TValue, KeyValuePair<TPriority, TValue>> values;
+    private IComparer<TPriority> comparer;
+
+    #region Constructors
+
+    public PriorityQueue(IComparer<TPriority> comparer) {
+      if (comparer == null)
+        throw new ArgumentNullException();
+
+      heap = new List<KeyValuePair<TPriority, TValue>>();
+      values = new Dictionary<TValue, KeyValuePair<TPriority, TValue>>();
+      this.comparer = comparer;
+    }
+
+    #endregion
+
+    #region Priority queue methods
+
+    public void Enqueue(TPriority priority, TValue value) {
+      Insert(priority, value);
+    }
+
+    public KeyValuePair<TPriority, TValue> Dequeue() {
+      if (Count != 0) {
+        KeyValuePair<TPriority, TValue> item = heap[0];
+        RemoveRoot();
+        return item;
+      } else {
+        throw new InvalidOperationException("Priority queue is empty");
+      }
+    }
+
+    public TValue DequeueValue() {
+      return Dequeue().Value;
+    }
+
+    #endregion
+
+    #region ICollection members
+
+    public void Add(KeyValuePair<TPriority, TValue> item) {
+      Enqueue(item.Key, item.Value);
+    }
+
+    public void Clear() {
+      heap.Clear();
+      values.Clear();
+    }
+
+    public bool Contains(KeyValuePair<TPriority, TValue> item) {
+      return heap.Contains(item);
+    }
+
+    public bool Contains(TValue value) {
+      return values.ContainsKey(value);
+    }
+
+    public void CopyTo(KeyValuePair<TPriority, TValue>[] array, int arrayIndex) {
+      heap.CopyTo(array, arrayIndex);
+    }
+
+    public int Count {
+      get { return heap.Count; }
+    }
+
+    public bool IsReadOnly {
+      get { return false; }
+    }
+
+    public bool Remove(KeyValuePair<TPriority, TValue> item) {
+      int idx = heap.IndexOf(item);
+      if (idx < 0) {
+        return false;
+      }
+
+      values.Remove(item.Value);
+
+      heap[idx] = heap[heap.Count - 1];
+      heap.RemoveAt(heap.Count - 1);
+
+      HeapUp(idx);
+      HeapDown(idx);
+
+      return true;
+    }
+
+    public bool Remove(TValue value) {
+      KeyValuePair<TPriority, TValue> item = values[value];
+      return Remove(item);
+    }
+
+    #endregion
+
+    #region IEnumerable Members
+
+    public IEnumerator<KeyValuePair<TPriority, TValue>> GetEnumerator() {
+      return heap.GetEnumerator();
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return this.GetEnumerator();
+    }
+
+    #endregion
+
+    #region Private methods
+
+    private void SwapElements(int pos1, int pos2) {
+      KeyValuePair<TPriority, TValue> element = heap[pos1];
+      heap[pos1] = heap[pos2];
+      heap[pos2] = element;
+    }
+
+    private void Insert(TPriority priority, TValue value) {
+      KeyValuePair<TPriority, TValue> element = new KeyValuePair<TPriority, TValue>(priority, value);
+      heap.Add(element);
+      values.Add(value, element);
+
+      HeapUp(heap.Count - 1);
+    }
+
+    private void RemoveRoot() {
+      if (heap.Count <= 1) {
+        heap.Clear();
+        values.Clear();
+      } else {
+        KeyValuePair<TPriority, TValue> item = heap[0];
+        values.Remove(item.Value);
+
+        heap[0] = heap[heap.Count - 1];
+        heap.RemoveAt(heap.Count - 1);
+
+        HeapDown(0);
+      }
+    }
+
+    private void HeapUp(int pos) {
+      if (pos < heap.Count) {
+        while (pos > 0) {
+          int parent = (pos - 1) / 2;
+          if (comparer.Compare(heap[parent].Key, heap[pos].Key) > 0) {
+            SwapElements(parent, pos);
+            pos = parent;
+          } else {
+            break;
+          }
+        }
+      }
+    }
+
+    private void HeapDown(int pos) {
+      while (true) {
+        int smallest = pos;
+        int left = 2 * pos + 1;
+        int right = 2 * pos + 2;
+        if (left < heap.Count && comparer.Compare(heap[smallest].Key, heap[left].Key) > 0) {
+          smallest = left;
+        }
+        if (right < heap.Count && comparer.Compare(heap[smallest].Key, heap[right].Key) > 0) {
+          smallest = right;
+        }
+
+        if (smallest != pos) {
+          SwapElements(smallest, pos);
+          pos = smallest;
+        } else {
+          break;
+        }
+      }
+    }
+
+    #endregion
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/PriorityQueueOld.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/PriorityQueueOld.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Utilities/PriorityQueueOld.cs	(revision 8516)
@@ -0,0 +1,48 @@
+﻿
+using System;
+using System.Collections.Generic;
+namespace HeuristicLab.Algorithms.GraphRouting.Utilities {
+  public class PriorityQueueOld<P, T> where P : IComparable {
+    SortedList<Pair<P>, T> list;
+    P dummy;
+
+    public PriorityQueueOld() {
+      list = new SortedList<Pair<P>, T>(new PairComparer<P>());
+    }
+
+    public int Count {
+      get { return list.Count; }
+    }
+
+    public void Enqueue(T item, P priority) {
+      list.Add(new Pair<P>(priority, dummy), item);
+      //count++;
+    }
+
+    public T Dequeue() {
+      T item = list[list.Keys[0]];
+      list.RemoveAt(0);
+      return item;
+    }
+
+    public bool Contains(T item) {
+      return list.ContainsValue(item);
+    }
+
+    public bool Remove(T item) {
+      bool delete = false;
+      KeyValuePair<Pair<P>, T> toDelete = new KeyValuePair<Pair<P>, T>();
+      foreach (var pair in list) {
+        if (pair.Value.Equals(item)) {
+          delete = true;
+          toDelete = pair;
+        }
+      }
+      if (delete) {
+        return list.Remove(toDelete.Key);
+      }
+      return false;
+    }
+
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning.Test/Program.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning.Test/Program.cs	(revision 8515)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning.Test/Program.cs	(revision 8516)
@@ -7,19 +7,22 @@
 using System.Xml;
 using HeuristicLab.Algorithms.GraphRouting;
-using HeuristicLab.Problems.RoutePlanning.Graph;
-using HeuristicLab.Problems.RoutePlanning.Osm;
-using HeuristicLab.Problems.RoutePlanning.Osm.Data;
+using HeuristicLab.Algorithms.GraphRouting.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.Data.DIMACS;
+using HeuristicLab.Problems.RoutePlanning.Data.Osm;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.RoutingGraph;
+
+// For testing openstreetmap data is used
+// http://www.openstreetmap.org
+// Map data © OpenStreetMap contributors, CC BY-SA
+
 namespace HeuristicLab.Problems.RoutePlanning.Test {
   class Program {
     static void Main(string[] args) {
-      // For testing openstreetmap data is used
-      // http://www.openstreetmap.org
-      // Map data © OpenStreetMap contributors, CC BY-SA
-
       string file1 = @"..\..\OsmTestFiles\test.osm";
       string file2 = @"..\..\OsmTestFiles\testNode1.osm";
       string file3 = @"..\..\OsmTestFiles\testWay1.osm";
       string file4 = @"..\..\OsmTestFiles\testRelation1.osm";
-      string file5 = @"..\..\OsmTestFiles\test_mid.osm";
+      string file5 = @"C:\dev\osmfiles\test_mid.osm";
       string file6 = @"C:\dev\osmfiles\oberosterreich.highway.osm";
       string file7 = @"C:\dev\osmfiles\austria.highway.osm";
@@ -29,58 +32,29 @@
       string fileNYCoords = @"C:\dev\DIMACSfiles\USA-road-d.NY.co.gz";
 
-      //IDataSource ds = TestLoad(typeof(XmlDataSource), file7);
-      //IDataSource ds = TestLoad(typeof(OsmDataSource), file6);
-      //OsmGraph graph = new OsmGraph(ds);
-
-      //IGraph graphNew = TestGetRoutingGraph(ds);
-      //ExecuteBenchmark(graphNew, typeof(AStarAlgorithmV3), 262144, 20);
-
-      //IRouter router = new AStarAlgorithmV3(graphNew);
+      IDataSource ds1 = TestLoad(typeof(OsmDataSource), file6);
+      IDataSource ds2 = TestLoad(typeof(DIMACSDataSource), fileNYCoords, fileNYArcs);
+
+      //IGraph graph = TestGetRoutingGraph(ds1);
+      //ExecuteBenchmark(graph, typeof(AStarAlgorithmV3), 262144, 20);
+
+      //IRouter router = new AStarAlgorithmV3(graph);
       //long[] r = router.Calculate(266733493, 986825165);
-      ////long[] r = router.Calculate(998717680, 986825165);
-
-      //IDataSource ds = new DIMACSDataSource(fileNYCoords, fileNYArcs);
-      //IDataSource ds = new OsmDataSource(file5);
-
-      //TestRouter(new DijkstraAlgorithm(graph), 529102170, 1001363194, true);
-      //TestRouter(new DijkstraAlgorithmV2(graphNew), 529102170, 1001363194, true);
-      //TestRouter(new DijkstraAlgorithm(graph), 529102170, 31372732, false); // inz - hgb
-      //TestRouter(new DijkstraAlgorithmV2(graphNew), 529102170, 31372732, false); // inz - hgb
-      //TestRouter(new BidrectionalDijkstraAlgorithm(graph), 529102170, 31372732, false); // inz - hgb
-      //TestRouter(new BidrectionalDijkstraAlgorithmV2(graphNew), 529102170, 31372732, false); // inz - hgb
-      //TestRouter(new AStarAlgorithm(graph), 529102170, 31372732, false); // inz - hgb
-      //TestRouter(new AStarAlgorithmV2(graph), 529102170, 31372732, false); // inz - hgb
-      //TestRouter(new AStarAlgorithmV3(graphNew), 529102170, 31372732, false); // inz - hgb
-
-      //TestRouter(new AStarAlgorithmV2(graph), 763113382, 1078628481, false); // bregenz (bahnhofstr) - podersdorf (??)
-      //TestRouter(new AStarAlgorithmV3(graphNew), 346151602, 33196510, false); // bregenz (bahnhofstr) - wien (stepansplatz)
-      //TestRouter(new AStarAlgorithmV2(graph), 346151602, 33196510, false); // bregenz (bahnhofstr) - wien (stepansplatz)
-
-      //TestRouter(new AStarAlgorithmV2(graph), 32044987, 261576106, false);    //vorarblberg
-      //TestRouter(new AStarAlgorithmV3(graphNew), 32044987, 261576106, false);    //vorarblberg
-
-      //TestLoadAndRouter(file6, typeof(DijkstraAlgorithm), 529102170, 31372732, false, false); // inz - hgb
-      //TestLoadAndRouter(file6, typeof(AStarAlgorithm), 529102170, 31372732, false, false); // inz - hgb
-      //TestLoadAndRouter(file6, typeof(AStarAlgorithmV2), 529102170, 31372732, false, true); // inz - hgb
-
-      //TestLoadAndRouter(file6, typeof(DijkstraAlgorithm), 529102170, 1001363194, true, false);
-      //TestLoadAndRouter(file6, typeof(DijkstraAlgorithm), 529102170, 1001363194, true, false);
-      //TestLoadAndRouter(file6, typeof(AStarAlgorithm), 529102170, 1001363194, true, false);
-      //TestLoadAndRouter(file6, typeof(AStarAlgorithmV2), 529102170, 1001363194, true, false);
-      //TestLoadAndRouter(file6, typeof(BidrectionalDijkstraAlgorithm), 529102170, 1001363194, true, false);
-
-      //TestLoadAndRouter(file5, typeof(DijkstraAlgorithm), 529102170, 1001363194, true, false);
-      //TestLoadAndRouter(file5, typeof(BidrectionalDijkstraAlgorithm), 529102170, 1001363194, true, true);
-      //TestLoadAndRouter(file6, typeof(BidrectionalDijkstraAlgorithm), 529102170, 31372732, false, true); // inz - hgb
-
-      TestLoadAndRouterNew(file6, typeof(AStarAlgorithmV3), 529102170, 31372732, false, true); // inz - hgb
-      //TestLoadAndRouterNew(file6, typeof(DijkstraAlgorithmV2), 529102170, 31372732, false, true);
-      //TestLoadAndRouterNew(file6, typeof(BidrectionalDijkstraAlgorithmV2), 529102170, 31372732, false, true);
-      //TestLoadAndRouterNew(file6, typeof(AStarAlgorithmV3), 529102170, 31372732, false, true);
-
-      //TestLoadAndRouter(file7, typeof(AStarAlgorithmV2), 346151602, 33196510, false, true); // bregenz (bahnhofstr) - wien (stepansplatz)
-      //TestLoadAndRouterNew(file7, typeof(AStarAlgorithmV3), 346151602, 33196510, false, true); // bregenz (bahnhofstr) - wien (stepansplatz)
-
-      //TestLoadAndRouter(file8, typeof(AStarAlgorithmV2), 32044987, 261576106, false, true);    //vorarblberg
+      //long[] r = router.Calculate(998717680, 986825165);
+
+      //TestRouter(new DijkstraAlgorithmV2(graph), 529102170, 1001363194, true); // inz
+
+      //TestRouter(new DijkstraAlgorithmV2(graph), 529102170, 31372732, false); // inz - hgb
+      //TestRouter(new BidrectionalDijkstraAlgorithmV2(graph), 529102170, 31372732, false); // inz - hgb
+      //TestRouter(new AStarAlgorithmV3(graph), 529102170, 31372732, false); // inz - hgb
+
+      //TestRouter(new AStarAlgorithmV3(graph), 346151602, 33196510, false); // bregenz (bahnhofstr) - wien (stepansplatz)
+
+      //TestRouter(new AStarAlgorithmV3(graph), 32044987, 261576106, false);    //vorarblberg
+
+      //TestLoadAndRouter(typeof(OsmDataSource), file6, typeof(AStarAlgorithmV3), 529102170, 31372732, false, true); // inz - hgb
+      //TestLoadAndRouter(typeof(OsmDataSource), file6, typeof(DijkstraAlgorithmV2), 529102170, 31372732, false, true); // inz - hgb
+      //TestLoadAndRouter(typeof(OsmDataSource), file6, typeof(BidrectionalDijkstraAlgorithmV2), 529102170, 31372732, false, true); // inz - hgb
+      //TestLoadAndRouter(typeof(OsmDataSource), file6, typeof(AStarAlgorithmV3), 529102170, 31372732, false, true); // inz - hgb
+      //TestLoadAndRouter(typeof(OsmDataSource), file7, typeof(AStarAlgorithmV3), 346151602, 33196510, false, true); // bregenz (bahnhofstr) - wien (stepansplatz)
 
       System.Console.Read();
@@ -126,5 +100,5 @@
     }
 
-    private static void TestLoadAndRouter(string filepath, Type routerType, long sourceNodeId, long targetNodeId, bool showResult, bool writeResultFile) {
+    private static void TestLoadAndRouter(Type dsType, string filepath, Type routerType, long sourceNodeId, long targetNodeId, bool showResult, bool writeResultFile) {
       FileInfo file = new FileInfo(filepath);
       Console.WriteLine("Test Load and Route BEGIN -------------------------");
@@ -133,10 +107,10 @@
       Console.Write("Loading data ... ");
       var sw = Stopwatch.StartNew();
-      XmlDataSource xmlDs = new XmlDataSource(filepath);
+      IDataSource ds = (IDataSource)Activator.CreateInstance(dsType, filepath);
       sw.Stop();
       Console.WriteLine("done.");
       Console.WriteLine("Loading Time: {0}", sw.Elapsed);
       Console.WriteLine();
-      OsmGraph graph = new OsmGraph(xmlDs);
+      IGraph graph = ds.GetRoutingGraph();
       IRouter router = (IRouter)Activator.CreateInstance(routerType, graph);
       Console.Write("Calculate route ... ");
@@ -164,90 +138,5 @@
     }
 
-    private static void TestLoadAndRouterNew(string filepath, Type routerType, long sourceNodeId, long targetNodeId, bool showResult, bool writeResultFile) {
-      FileInfo file = new FileInfo(filepath);
-      Console.WriteLine("Test Load and Route BEGIN -------------------------");
-      Console.WriteLine("File name: {0}", file.Name);
-      Console.WriteLine();
-      Console.Write("Loading data ... ");
-      var sw = Stopwatch.StartNew();
-      //XmlDataSource xmlDs = new XmlDataSource(filepath);
-      IDataSource xmlDs = new OsmDataSource(filepath);
-      sw.Stop();
-      Console.WriteLine("done.");
-      Console.WriteLine("Loading Time: {0}", sw.Elapsed);
-      Console.WriteLine();
-      IGraph graph = xmlDs.GetRoutingGraph();
-      IRouter router = (IRouter)Activator.CreateInstance(routerType, graph);
-      Console.Write("Calculate route ... ");
-      sw = Stopwatch.StartNew();
-      long[] result = router.Calculate(sourceNodeId, targetNodeId);
-      sw.Stop();
-      Console.WriteLine("done.");
-      Console.WriteLine("Execution Time: {0}", sw.Elapsed);
-      Console.WriteLine();
-      if (showResult) {
-        Console.WriteLine("Result: ");
-        foreach (long i in result) System.Console.Write(i + "; ");
-        Console.WriteLine();
-        Console.WriteLine();
-      }
-      if (writeResultFile) {
-        string dt = DateTime.Now.ToString("yyyyMMddhhmmss_");
-        string fn = Path.GetFileNameWithoutExtension(file.Name);
-        string resultFile = dt + fn + "_" + sourceNodeId + "-" + targetNodeId + ".gpx";
-        Console.WriteLine("Result file: {0}", resultFile);
-        WriteGPXFileNew(graph, result, resultFile);
-      }
-      Console.WriteLine("===================================================");
-      Console.WriteLine();
-    }
-
-    private static void WriteGPXFile(OsmGraph graph, long[] route, string file) {
-      XmlWriterSettings settings = new XmlWriterSettings();
-      settings.Indent = true;
-      settings.IndentChars = ("   ");
-
-      using (XmlWriter writer = XmlWriter.Create(file, settings)) {
-        writer.WriteStartElement("gpx", "http://www.topografix.com/GPX/1/0");
-        writer.WriteAttributeString("version", "1.1");
-        writer.WriteAttributeString("creator", "cloudia");
-
-        foreach (long nodeId in route) {
-          OsmVertex<Node> node = graph.GetVertex(nodeId);
-          writer.WriteStartElement("wpt");
-          writer.WriteAttributeString("lat", XmlConvert.ToString(node.Node.Latitude));
-          writer.WriteAttributeString("lon", XmlConvert.ToString(node.Node.Longitude));
-          writer.WriteEndElement(); // wpt
-        }
-
-        //writer.WriteStartElement("rte");
-        //foreach (long nodeId in route) {
-        //  Vertex<Node> node = graph.GetVertex(nodeId);
-        //  writer.WriteStartElement("rtept");
-        //  writer.WriteAttributeString("lat", XmlConvert.ToString(node.Node.Latitude));
-        //  writer.WriteAttributeString("lon", XmlConvert.ToString(node.Node.Longitude));
-        //  writer.WriteEndElement(); // rtept
-        //}
-        //writer.WriteEndElement(); // rte
-
-        //writer.WriteStartElement("trk");
-        //writer.WriteElementString("name", "RoutePath");
-        ////writer.WriteEndElement(); // name
-        //writer.WriteStartElement("trkseq");
-        //foreach (long nodeId in route) {
-        //  Vertex<Node> node = graph.GetVertex(nodeId);
-        //  writer.WriteStartElement("trkpt");
-        //  writer.WriteAttributeString("lat", XmlConvert.ToString(node.Node.Latitude));
-        //  writer.WriteAttributeString("lon", XmlConvert.ToString(node.Node.Longitude));
-        //  writer.WriteEndElement(); // trkpt
-        //}
-        //writer.WriteEndElement(); // trkseq
-        //writer.WriteEndElement(); // trk
-
-        writer.WriteEndElement(); // gpx
-      }
-    }
-
-    private static void WriteGPXFileNew(IGraph graph, long[] route, string file) {
+    private static void WriteGPXFile(IGraph graph, long[] route, string file) {
       XmlWriterSettings settings = new XmlWriterSettings();
       settings.Indent = true;
@@ -267,28 +156,4 @@
         }
 
-        //writer.WriteStartElement("rte");
-        //foreach (long nodeId in route) {
-        //  Vertex<Node> node = graph.GetVertex(nodeId);
-        //  writer.WriteStartElement("rtept");
-        //  writer.WriteAttributeString("lat", XmlConvert.ToString(node.Node.Latitude));
-        //  writer.WriteAttributeString("lon", XmlConvert.ToString(node.Node.Longitude));
-        //  writer.WriteEndElement(); // rtept
-        //}
-        //writer.WriteEndElement(); // rte
-
-        //writer.WriteStartElement("trk");
-        //writer.WriteElementString("name", "RoutePath");
-        ////writer.WriteEndElement(); // name
-        //writer.WriteStartElement("trkseq");
-        //foreach (long nodeId in route) {
-        //  Vertex<Node> node = graph.GetVertex(nodeId);
-        //  writer.WriteStartElement("trkpt");
-        //  writer.WriteAttributeString("lat", XmlConvert.ToString(node.Node.Latitude));
-        //  writer.WriteAttributeString("lon", XmlConvert.ToString(node.Node.Longitude));
-        //  writer.WriteEndElement(); // trkpt
-        //}
-        //writer.WriteEndElement(); // trkseq
-        //writer.WriteEndElement(); // trk
-
         writer.WriteEndElement(); // gpx
       }
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.DIMACS/DIMACSDataSource.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.DIMACS/DIMACSDataSource.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.DIMACS/DIMACSDataSource.cs	(revision 8516)
@@ -0,0 +1,121 @@
+﻿using System;
+using System.IO;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.RoutingGraph;
+using ICSharpCode.SharpZipLib.GZip;
+
+namespace HeuristicLab.Problems.RoutePlanning.Data.DIMACS {
+  public class DIMACSDataSource : IDataSource {
+    FileInfo graphFile;
+    FileInfo coordinatesFile;
+
+    IGraph graph;
+
+    public DIMACSDataSource(string coordinates, string inputgraph) {
+      coordinatesFile = new FileInfo(coordinates);
+      graphFile = new FileInfo(inputgraph);
+      graph = new Graph();
+      ReadData();
+    }
+
+    #region IDataSource Members
+
+    public IGraph GetRoutingGraph() {
+      return graph;
+    }
+
+    #endregion
+
+    #region Private Methods
+
+    private void ReadData() {
+      using (FileStream fs = File.OpenRead(coordinatesFile.FullName))
+      using (GZipInputStream input = new GZipInputStream(fs)) {
+        string s = "";
+
+        int i;
+
+        while ((i = input.ReadByte()) != -1) {
+          char c = (char)i;
+          if (c == '\r' || c == '\n') {
+            if (s.StartsWith("c")) {
+              if (s.Length > 1) {
+                // comment
+                Console.WriteLine(s);
+              }
+            } else if (s.StartsWith("p")) {
+              string[] line = s.Split(' ');
+              if (line[1] == "aux" && line[2] == "sp" && line[3] == "co") {
+                int vertices = int.Parse(line[4]);
+                Console.WriteLine("vertices: {0}", vertices);
+              } else {
+                throw new ArgumentException("Wrong problem format");
+              }
+            } else if (s.StartsWith("v")) {
+              string[] line = s.Split(' ');
+
+              long id = int.Parse(line[1]);
+              double lon = double.Parse(line[2]);
+              double lat = double.Parse(line[3]);
+
+              Vertex v = new Vertex(id, lon, lat);
+              graph.AddVertex(v);
+            }
+            s = string.Empty;
+          } else {
+            s += c;
+          }
+        }
+      }
+
+
+      using (FileStream fs = File.OpenRead(graphFile.FullName))
+      using (GZipInputStream input = new GZipInputStream(fs)) {
+        string s = "";
+
+        int i;
+
+        while ((i = input.ReadByte()) != -1) {
+          char c = (char)i;
+          if (c == '\r' || c == '\n') {
+            if (s.StartsWith("c")) {
+              if (s.Length > 1) {
+                // comment
+                Console.WriteLine(s);
+              }
+            } else if (s.StartsWith("p")) {
+              string[] line = s.Split(' ');
+              if (line[1] == "sp") {
+                int vertices = int.Parse(line[2]);
+                int edges = int.Parse(line[3]);
+                Console.WriteLine("vertices: {0}; edges: {1}", vertices, edges);
+              } else {
+                throw new ArgumentException("Wrong problem format");
+              }
+            } else if (s.StartsWith("a")) {
+              string[] line = s.Split(' ');
+
+              long src = int.Parse(line[1]);
+              long dst = int.Parse(line[2]);
+              int len = int.Parse(line[3]);
+
+              Vertex vSrc = graph.GetVertex(src);
+              Vertex vDst = graph.GetVertex(dst);
+
+              Edge<Vertex> edge = new Edge<Vertex>(vSrc, vDst);
+              edge.Weight = len;
+
+              graph.AddEdge(edge);
+
+            }
+            s = string.Empty;
+          } else {
+            s += c;
+          }
+        }
+      }
+    }
+
+    #endregion
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Node.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Node.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Data.Osm.Core/Node.cs	(revision 8516)
@@ -0,0 +1,29 @@
+﻿
+using HeuristicLab.Problems.RoutePlanning.Utilities;
+namespace HeuristicLab.Problems.RoutePlanning.Data.Osm.Core {
+  public class Node : OsmBase {
+    private PointD point;
+
+    public double Longitude {
+      get { return point.X; }
+      set { point.X = value; }
+    }
+    public double Latitude {
+      get { return point.Y; }
+      set { point.Y = value; }
+    }
+
+    public PointD Point {
+      get { return point; }
+    }
+
+    public Node() {
+      point = new PointD();
+    }
+
+    public Node(long id, double lat, double lon)
+      : base(id) {
+      point = new PointD(lat, lon);
+    }
+  }
+}
